`ifndef HOST_INTF_CLASS
`define HOST_INTF_CLASS

`ifndef INPUT_EDGE
`define INPUT_EDGE   PSAMPLE `-1
`endif
`ifndef OUTPUT_EDGE
`define OUTPUT_EDGE  PHOLD  `1
`endif


interface host_intf (input logic clk);

    wire        CPU_init_end   ;   
    wire        Rx_mac_ra      ;   
    wire [31:0] Rx_mac_data    ;  
    wire [1:0]  Rx_mac_BE      ;  
    wire        Rx_mac_pa      ;  
    wire        Rx_mac_sop     ;  
    wire        Rx_mac_eop     ;  
    wire        Tx_mac_wa      ;    
    
    wire         Reset         ;   
    wire         Rx_mac_rd     ;   
    wire         Tx_mac_wr     ;        
    wire [31:0]  Tx_mac_data   ;    
    wire [1 :0]  Tx_mac_BE     ;    
    wire         Tx_mac_sop    ;    
    wire         Tx_mac_eop    ; 
    
    parameter SETUP_TIME = 1;
    parameter HOLD_TIME = 1;
    
    clocking cb@(posedge clk);
      default input #SETUP_TIME output #HOLD_TIME;
    
      input         CPU_init_end  ;   
      input         Rx_mac_ra     ;   
      input         Rx_mac_data   ;  
      input         Rx_mac_BE     ;  
      input         Rx_mac_pa     ;  
      input         Rx_mac_sop    ;  
      input         Rx_mac_eop    ;  
      input         Tx_mac_wa     ;    
      
      output        Reset         ;   
      output        Rx_mac_rd     ;   
      output        Tx_mac_wr     ;        
      output        Tx_mac_data   ;    
      output        Tx_mac_BE     ;    
      output        Tx_mac_sop    ;    
      output        Tx_mac_eop    ;     
    
    endclocking 
    
endinterface 


`endif

